package com.huimv.admin.timer;


import cn.hutool.core.codec.Base64;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.huimv.admin.common.utils.Digests;
import com.huimv.admin.common.utils.HttpClientSSLUtils;
import com.huimv.admin.entity.*;
import com.huimv.admin.entity.zengxindto.*;
import com.huimv.admin.service.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.*;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.client.RestTemplate;

import java.time.LocalDate;
import java.util.*;

@Configuration
@EnableScheduling
public class ShenChanTimer {

    //生产数据
    @Autowired
    private RestTemplate restTemplate;
    @Autowired
    private IProdStockService prodStockService;


//    @Scheduled(cron = "0 0 */4 * * ? ")
    @Scheduled(cron = "0 0 * * * ?")
//    @GetMapping("/test")
    private void getShenChan() throws Exception {
        String token = login();
        DateTime dateTime = DateUtil.beginOfDay(new Date());
        String data =   getList(token);
        ProdStockDto prodStockDto = JSONUtil.toBean(data, ProdStockDto.class);
        List<List<Object>> stockData = prodStockDto.getData();

        for (List stock : stockData) {
            switch (stock.get(0).toString()) {
                case "正康":
                    saveProdStrok(21,stock,dateTime);
                    break;
                case "东阳":
                    saveProdStrok(24,stock,dateTime);
                    break;
                case "浦江":
                    saveProdStrok(23,stock,dateTime);
                    break;
                case "横路":
                    saveProdStrok(26,stock,dateTime);
                    break;
                case "天台":
                    saveProdStrok(27,stock,dateTime);
                    break;
                case "平望":
                    saveProdStrok(28,stock,dateTime);
                    break;
                case "张村":
                    saveProdStrok(29,stock,dateTime);
                    break;
                default:
                    break;
            }
        }
    }
    //保存存栏
    private void saveProdStrok(Integer farmId,List stock,DateTime dateTime) {
        ProdStock prodStock = prodStockService.getOne(new QueryWrapper<ProdStock>().ge("creat_time", dateTime).eq("farm_id", farmId).orderByDesc("creat_time").last("limit 1"));
        Boolean isNew = false;
        if(ObjectUtil.isEmpty(prodStock)){
            prodStock = new ProdStock();
             isNew = true;
        }
        prodStock.setHbzcl(Integer.parseInt(stock.get(3).toString()));
        prodStock.setGzcl(Integer.parseInt(stock.get(4).toString()));
        prodStock.setKhzcl(Integer.parseInt(stock.get(6).toString()));

        prodStock.setZzcl(Integer.parseInt(stock.get(12).toString()));
        prodStock.setByzcl(Integer.parseInt(stock.get(13).toString()));
        prodStock.setYfzcl(Integer.parseInt(stock.get(15).toString()));
        prodStock.setZcl(Integer.parseInt(stock.get(16).toString()));

        if (isNew) {
            prodStock.setMzcl(100);
            prodStock.setBrzcl(452);
            prodStock.setRszcl(30);
            prodStock.setBrmzcl(20);
            prodStock.setSpzcl(1020);
            prodStock.setCreatTime(new Date());
            prodStock.setDisplayType(0);
            prodStock.setFarmId(farmId);
            prodStockService.save(prodStock);
        } else {

            prodStockService.updateById(prodStock);
        }

    }

    //获取数据
    private String getList(String token) throws Exception {
        String time = LocalDate.now().toString();
        String url = "http://test.htpig.cn/rest/db/storedproc";
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("db_name", "MSSQL");
        map.put("proc_name", "rep_yz_kc_hz");
        map.put("method", "open_proc");
        HashMap<String, Object> maps = new HashMap<>();
        List list = new ArrayList();
        maps.put("name", "@fdate");
        maps.put("value", time);
        list.add(maps);
        map.put("params", list);
        String params = JSON.toJSONString(map);
        String data = HttpClientSSLUtils.doPost(url + "?token=" + token + "&data=", params);
        return data;

    }


    public static void main(String[] args) throws Exception {
        RestTemplate restTemplate = new RestTemplate();
        StockLoginDto stockLoginDto = restTemplate.getForObject("http://test.htpig.cn/rest/user/login?user_name=test&password=e10adc3949ba59abbe56e057f20f883e&db_name=MSSQL", StockLoginDto.class);
        String token = stockLoginDto.getToken();
        String time = LocalDate.now().toString();
        String url = "http://test.htpig.cn/rest/db/storedproc";
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("db_name", "MSSQL");
        map.put("proc_name", "rep_yz_kc_hz");
        map.put("method", "open_proc");
        HashMap<String, Object> maps = new HashMap<>();
        List list = new ArrayList();
        maps.put("name", "@fdate");
        maps.put("value", time);
        list.add(maps);

        map.put("params", list);
        String params = JSON.toJSONString(map);
        System.out.println(" ====== getStock请求参数：【" + params + "】");
        String data = HttpClientSSLUtils.doPost(url + "?token=" + token + "&data=", params);
        ProdStockDto prodStockDto = JSONUtil.toBean(data, ProdStockDto.class);
    }

    private  String login() throws Exception {
        StockLoginDto stockLoginDto = restTemplate.getForObject("http://test.htpig.cn/rest/user/login?user_name=test&password=e10adc3949ba59abbe56e057f20f883e&db_name=MSSQL", StockLoginDto.class);
        if (stockLoginDto.getStatus() != 0) {
            return null;
        }
        return stockLoginDto.getToken();
    }

}
